#include <bits/stdc++.h>
#pragma GCC target ("avx2")
#pragma GCC optimize ("O3")
#pragma GCC optimize ("unroll-loops")

using namespace std;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;
void solve()
{
    int n;
    cin>>n;
    vi a;
    a.rs(n);
    vi b;
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    b=a;
    ll ans=0;
    vpl tp;
    sort(all(b));
    for(int i=0;i<n;i++){
        if(a[i]==b[i]) continue;
        for(int j=i+1;j<n;j++){
            if(a[j]==b[i]){
                ans++;
                tp.pb({i+1, j+1});
                if(j-i-1>1){
                    ans++;
                    tp.pb({i+2, j});
                }
                swap(a[i], a[j]);
                break;
            }
        }
    }
    cout<<ans<<endl;
    for(auto i:tp){
        cout<<i.F<<" "<<i.S<<endl;
    }

}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    //cin>>t;
    while (t--)
        solve();

}
/*

*/
